package com.persagy.apm.report.dependencies.energyefficiencyweb.client;

import com.persagy.apm.common.response.PoemsFeignResponse;
import com.persagy.apm.report.common.constants.FeignClientNameConstants;
import com.persagy.apm.report.common.config.FeignConfig;
import com.persagy.apm.report.dependencies.energyefficiencyweb.client.fallback.EnergyEfficiencyClientFallbackFactory;
import com.persagy.apm.report.dependencies.energyefficiencyweb.model.vo.EnergyEfficiencyDataListVO;
import feign.Headers;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * 能效情况feign客户端
 **/
@FeignClient(name = FeignClientNameConstants.ENERGY_EFFICIENCY,
        fallbackFactory = EnergyEfficiencyClientFallbackFactory.class,
        configuration = FeignConfig.class)
public interface EnergyEfficiencyClient {
    /**
     * 根据条件查询能效情况
     *
     * @param queryEnergyEfficientDataDTO 查询条件
     * @return 平均达标率
     * @author wch
     * @version V1.0 2021/5/19 2:27 下午
     */
    @PostMapping("/Spring/MVC/entrance/unifier/queryProjectTargetDataList")
    @Headers({"Content-Type: application/x-www-form-urlencoded"})
    PoemsFeignResponse<EnergyEfficiencyDataListVO> queryProjectTargetDataList(
            @RequestParam("jsonString") String queryEnergyEfficientDataDTO);
}
