package com.persagy.apm.report.indicator.manualfilling.service;

import com.persagy.apm.report.indicator.manualfilling.model.*;
import com.persagy.apm.report.indicator.manualfilling.model.dto.*;

import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 数据录入数据(ManualFillingData) service接口
 *
 * @author lixing
 * @version V1.0 2021-07-27 09:52:19
 */
public interface IManualFillingDataService {

    /**
     * 创建数据录入数据
     *
     * @param addManualFillingDataDTO addDTO
     * @return 数据录入数据主键
     * @author lixing
     * @version V1.0 2021-07-27 09:52:19
     */
    String createManualFillingData(AddManualFillingDataDTO addManualFillingDataDTO);

    /**
     * 数据录入数据详情
     *
     * @param id 主键
     * @return 数据录入数据do对象
     * @author lixing
     * @version V1.0 2021-07-27 09:52:19
     */
    ManualFillingData queryManualFillingDataDetail(String id);

    /**
     * 更新数据录入数据
     *
     * @param updateManualFillingDataDTO updateDTO
     * @author lixing
     * @version V1.0 2021-07-27 09:52:19
     */
    void updateManualFillingData(UpdateManualFillingDataDTO updateManualFillingDataDTO);

    /**
     * 删除数据录入数据
     *
     * @param id 主键
     * @author lixing
     * @version V1.0 2021-07-27 09:52:19
     */
    void deleteManualFillingData(String id);

    /**
     * 查询数据录入数据
     *
     * @param queryManualFillingDataDTO queryDTO
     * @return List<ManualFillingData>
     * @author lixing
     * @version V1.0 2021-07-27 09:52:19
     */
    List<ManualFillingData> queryManualFillingDataList(QueryManualFillingDataDTO queryManualFillingDataDTO);

    /**
     * 分页查询数据录入数据
     *
     * @param pageQueryManualFillingDataDTO pageQueryDTO
     * @return IPage<ManualFillingData>
     * @author lixing
     * @version V1.0 2021-07-27 09:52:19
     */
    IPage<ManualFillingData> pageQueryManualFillingData(PageQueryManualFillingDataDTO pageQueryManualFillingDataDTO);

    /**
     * 批量删除
     *
     * @param functionId 指标id
     * @param projectId 项目id
     * @param deleteDates 要删除的日期列表
     * @author lixing
     * @version V1.0 2021/7/27 11:56 上午
     */
    void batchDelete(String functionId, String projectId, List<Date> deleteDates);

    /**
     * 批量保存
     *
     * @param manualFillingDataList 要保存的人工录入数据
     * @author lixing
     * @version V1.0 2021/7/27 11:57 上午
     */
    void batchSave(List<ManualFillingData> manualFillingDataList);
}
