package com.persagy.apm.report.outline.service.builder;

import com.persagy.apm.report.outline.model.ReportOutline;

/**
 * 生成商业报告建造者接口
 *
 * @author lixing
 * @version V1.0 2021/5/30 10:26 下午
 **/
public interface IReportGenerator {
    /**
     * 生成报告。建造方法
     *
     * @param reportOutline 报告outline对象
     * @author lixing
     * @version V1.0 2021/5/24 4:09 下午
     */
    void generateReport(ReportOutline reportOutline);

    /**
     * 删除报告的段落数据
     *
     * @param reportOutline 报告概要对象
     * @author lixing
     * @version V1.0 2021/5/31 4:19
     */
    void deleteReportParagraphs(ReportOutline reportOutline);

    /**
     * 生成报告详情
     *
     * @param reportOutline 需要更新的报告概要
     * @return 是否生成成功
     * @author lixing
     * @version V1.0 2021/5/31 4:26 下午
     */
    boolean generateParagraphs(ReportOutline reportOutline);

    /**
     * 成功时更新报告概要
     *
     * @param reportOutline 需要更新的报告概要
     * @author lixing
     * @version V1.0 2021/5/31 4:26 下午
     */
    void updateReportOutlineInfoWhenSuccess(ReportOutline reportOutline);

    /**
     * 失败时更新报告概要
     *
     * @param reportOutline 需要更新的报告概要
     * @author lixing
     * @version V1.0 2021/5/31 4:26 下午
     */
    void updateReportOutlineInfoWhenFailure(ReportOutline reportOutline);
}
