package com.persagy.apm.report.paragraphs.service.impl.energyefficiency;

import com.google.gson.Gson;
import com.google.gson.JsonSyntaxException;
import com.persagy.apm.report.userconfig.function.model.Function;
import com.persagy.apm.report.userconfig.function.service.IFunctionService;
import com.persagy.apm.report.detail.model.vo.AttrValueVO;
import com.persagy.apm.report.detail.model.vo.GroupVO;
import com.persagy.apm.report.detail.model.vo.ItemVO;
import com.persagy.apm.report.detail.paragraphvalue.model.vo.ParagraphContentVO;
import com.persagy.apm.report.indicator.factory.EnergyEfficiencyFactory;
import com.persagy.apm.report.indicator.model.entity.EnergyEfficiencyDefine;
import com.persagy.apm.report.outline.model.ReportOutline;
import com.persagy.apm.report.paragraphs.service.impl.ProjectParagraphBuilder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * 能效情况单项目段落建造者
 *
 * @author lixing
 * @version V1.0 2021/7/26 4:52 下午
 **/
@Service
public class ProjectEnergyEfficiencyBuilder extends ProjectParagraphBuilder {
    @Autowired
    EnergyEfficiencyFactory energyEfficiencyFactory;
    @Autowired
    IFunctionService functionService;

    @Override
    public List<AttrValueVO> getHeader(
            ParagraphContentVO paragraphContentVO, ReportOutline reportOutline) {
        return null;
    }

    @Override
    public List<AttrValueVO> getSummary(
            List<GroupVO> groupVOList, List<ItemVO> itemVOList, List<String> projectIdList) {

        return null;
    }

    @Override
    public ItemVO getProjectItemValue(String itemId, String projectId, Date reportMonth) {
        // 获取指标的定义，转换为指标对象
        Function function = functionService.queryFunctionDetail(itemId);
        Gson gson = new Gson();
        EnergyEfficiencyDefine energyEfficiencyDefine;
        try {
            energyEfficiencyDefine = gson.fromJson(function.getDefine(), EnergyEfficiencyDefine.class);
            if (energyEfficiencyDefine.getTargetCode() == null) {
                throw new IllegalArgumentException("能效情况定义配置错误，错误的定义内容为：" + function);
            }
        } catch (JsonSyntaxException e) {
            throw new IllegalArgumentException("能效情况定义配置错误，错误的定义内容为：" + function);
        }
        // 从指标库中获取指标取值
        return energyEfficiencyFactory.getEnergyEfficiencyInfo(function, energyEfficiencyDefine, projectId, reportMonth);
    }

    @Override
    public List<AttrValueVO> getProjectSummary(ParagraphContentVO projectParagraphContent) {
        return null;
    }
}
