package com.persagy.apm.report.userconfig.function.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.persagy.apm.common.model.entity.AuditableEntity;

import java.io.Serializable;

/**
 * 功能点(Function)实体类
 *
 * @author lixing
 * @version V1.0 2021-07-23 17:55:18
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(description = "功能点")
public class Function extends AuditableEntity<Function> implements Serializable {
    private static final long serialVersionUID = -77091037843226756L;

    @ApiModelProperty("功能点名称")
    private String name;

    @ApiModelProperty("功能点定义")
    private String define;

    @ApiModelProperty("数据来源")
    private String dataSource;

    @ApiModelProperty("合格标准")
    private String qualifiedStandard;

    @ApiModelProperty("备注")
    private String remark;


    public static String PROP_NAME = "name";
    public static String PROP_DEFINE = "define";
    public static String PROP_DATA_SOURCE = "data_source";
    public static String PROP_QUALIFIED_STANDARD = "qualifiedStandard";
    public static String PROP_REMARK = "remark";

}
