package com.persagy.apm.report.userconfig.function.service;

import com.persagy.apm.report.userconfig.function.model.*;
import com.persagy.apm.report.userconfig.function.model.dto.*;

import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.metadata.IPage;

/**
 * 功能点(Function) service接口
 *
 * @author lixing
 * @version V1.0 2021-07-23 17:55:17
 */
public interface IFunctionService {

    /**
     * 创建功能点
     *
     * @param addFunctionDTO addDTO
     * @return 功能点主键
     * @author lixing
     * @version V1.0 2021-07-23 17:55:17
     */
    String createFunction(AddFunctionDTO addFunctionDTO);

    /**
     * 功能点详情
     *
     * @param id 主键
     * @return 功能点do对象
     * @author lixing
     * @version V1.0 2021-07-23 17:55:17
     */
    Function queryFunctionDetail(String id);

    /**
     * 更新功能点
     *
     * @param updateFunctionDTO updateDTO
     * @author lixing
     * @version V1.0 2021-07-23 17:55:17
     */
    void updateFunction(UpdateFunctionDTO updateFunctionDTO);

    /**
     * 删除功能点
     *
     * @param id 主键
     * @author lixing
     * @version V1.0 2021-07-23 17:55:17
     */
    void deleteFunction(String id);

    /**
     * 查询功能点
     *
     * @param queryFunctionDTO queryDTO
     * @return List<Function>
     * @author lixing
     * @version V1.0 2021-07-23 17:55:17
     */
    List<Function> queryFunctionList(QueryFunctionDTO queryFunctionDTO);

    /**
     * 分页查询功能点
     *
     * @param pageQueryFunctionDTO pageQueryDTO
     * @return IPage<Function>
     * @author lixing
     * @version V1.0 2021-07-23 17:55:17
     */
    IPage<Function> pageQueryFunction(PageQueryFunctionDTO pageQueryFunctionDTO);

    /**
     * 根据指标定义查询符合条件的指标
     *
     * @param dataSource 数据来源
     * @param defineMap 指标定义 code -> value
     * @return 符合条件的指标列表
     * @author lixing
     * @version V1.0 2021/7/27 10:01 上午
     */
    List<Function> queryByDefine(String dataSource, Map<String, Object> defineMap);

}
