package com.persagy.apm.report.userconfig.paragraphmodel.model.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;

import lombok.Data;

/**
 * @author lixing
 * @version V1.0 2021-07-20 10:26:12
 */
@Data
@ApiModel(value = "更新段落模板入参")
public class UpdateParagraphModelDTO {
    @ApiModelProperty(value = "主键", required = true)
    @NotNull(message = "主键不能为空") // todo 更新校验规则
    private String id;

    @ApiModelProperty(value = "编码", required = true)
    @NotNull(message = "编码不能为空") // todo 更新校验规则
    private String code;

    @ApiModelProperty(value = "名称", required = true)
    @NotNull(message = "名称不能为空") // todo 更新校验规则
    private String name;

    @ApiModelProperty(value = "段落头部可使用的属性", required = true)
    @NotNull(message = "段落头部可使用的属性不能为空") // todo 更新校验规则
    private Object headerAvailableAttrs;

    @ApiModelProperty(value = "段落列表可使用的属性", required = true)
    @NotNull(message = "段落列表可使用的属性不能为空") // todo 更新校验规则
    private Object listAvailableAttrs;

    @ApiModelProperty(value = "补充说明", required = true)
    @NotNull(message = "补充说明不能为空") // todo 更新校验规则
    private Object supplement;

}
