package com.persagy.apm.report.userconfig.pargraphdefine.model;

import org.mapstruct.*;
import org.mapstruct.MappingTarget;
import org.mapstruct.factory.Mappers;
import com.persagy.apm.report.userconfig.pargraphdefine.model.vo.*;
import com.persagy.apm.report.userconfig.pargraphdefine.model.dto.*;

import java.util.List;

/**
 * 段落定义(ParagraphDefine) dto、vo、do转换工具类
 *
 * @author lixing
 * @version V1.0 2021-07-20 10:23:09 2021-07-20 10:23:09
 */
@Mapper(nullValueMappingStrategy = NullValueMappingStrategy.RETURN_DEFAULT,
        nullValueCheckStrategy = NullValueCheckStrategy.ALWAYS)
public interface ConvertParagraphDefineTool {

    ConvertParagraphDefineTool INSTANCE = Mappers.getMapper(ConvertParagraphDefineTool.class);

    /**
     * do转换为ResponseItemVO
     *
     * @param paragraphDefine do对象
     * @return ResponseItemVO
     * @author lixing
     * @version V1.0 2021-07-20 10:23:09
     */
    ParagraphDefineItemVO convert2ResponseItemDTO(ParagraphDefine paragraphDefine);

    /**
     * do转换为ResponseListItemVO
     *
     * @param paragraphDefine do对象
     * @return ResponseListItemVO
     * @author lixing
     * @version V1.0 2021-07-20 10:23:09
     */
    ParagraphDefineListItemVO convert2ResponseListItemDTO(ParagraphDefine paragraphDefine);

    /**
     * do列表转换为ResponseListItemVO列表
     *
     * @param paragraphDefineList do列表
     * @return ResponseListItemVO列表
     * @author lixing
     * @version V1.0 2021-07-20 10:23:09
     */
    List<ParagraphDefineListItemVO> convert2List(List<ParagraphDefine> paragraphDefineList);

    /**
     * addDTO转换为do
     *
     * @param addParagraphDefineDTO addDTO
     * @return 要创建的do对象
     * @author lixing
     * @version V1.0 2021-07-20 10:23:09
     */
    ParagraphDefine convertAddDto2Entity(AddParagraphDefineDTO addParagraphDefineDTO);

    /**
     * updateDTO转换为实体
     *
     * @param paragraphDefine          更新前的do对象
     * @param updateParagraphDefineDTO updateDTO
     * @return 更新后的do对象
     * @author lixing
     * @version V1.0 2021-07-20 10:23:09
     */
    ParagraphDefine convertUpdateDto2Entity(@MappingTarget ParagraphDefine paragraphDefine, UpdateParagraphDefineDTO updateParagraphDefineDTO);
}

