package com.persagy.apm.report.userconfig.reporttype.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.persagy.apm.common.model.entity.AuditableEntity;

import java.io.Serializable;

/**
 * 报告类型(ReportType)实体类
 *
 * @author lixing
 * @version V1.0 2021-05-19 10:39:17
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(description = "报告类型")
public class ReportType extends AuditableEntity<ReportType> implements Serializable {
    private static final long serialVersionUID = 102317093417294815L;

    @ApiModelProperty("报告类型名称")
    private String name;

    @ApiModelProperty("业态")
    private String buildingTypes;

    @ApiModelProperty("报告所属类型 enum 0-项目；1-大区")
    private String belongType;

    @ApiModelProperty("报告关联的段落")
    private String paragraphs;


    public static String PROP_NAME = "name";
    public static String PROP_BUILDING_TYPE = "building_type";
    public static String PROP_BELONG_TYPE = "belong_type";

}
